--[[
	ALL GLOBAL FUNCTIONS WILL BE CREATED HERE 
    WE CAN ACCESS THEM ANYWHERE IN THE APPLICATION.	
	Suffix "Util" after the name of function so we can identify that it is Utility function
   ]]


--Timer for the delay call
performAfterUtil = Timer.delayedCall
--[[usage eg => performAfterUtil(7000,function()  --arg1--> time in milliSec , arg2--> function
				etc..
				etc..
			 end)]]

-- Save score to a text file
function saveScoreUtil(score)
	local file=io.open("|D|score.txt","w+")
	file:write(math.floor(score) .. "\n")
	file:close()
end

-- Save HI score to a text file
function saveHiScoreUtil(hiScore)
	local file=io.open("|D|hiScore.txt","w+")
	file:write(math.floor(hiScore) .. "\n")
	file:close()
end

-- Load current score from file
function loadScoreUtil()
	local file = io.open("|D|score.txt","r")
	if not file then
		score = 0
	else
		score = tonumber(file:read("*line"))
		file:close()
	end
	return score
end

-- Load HI score from file
function loadHiScoreUtil()
	local file = io.open("|D|hiScore.txt","r")
	if not file then
		hiScore = 0
	else
		hiScore = tonumber(file:read("*line"))
		file:close()
	end
	return hiScore
end

--function for creating normal image
function drawImageUtil(x, y,imagename,scale,alpha)
	local img = Bitmap.new(Texture.new(imagename))
	img:setAnchorPoint(0.5,0.5)
	img:setPosition(x or 0,y or 0)	
	img:setScale(scale or 1)
	img:setAlpha(alpha or 1)
	--self:addChild(img) --add to respective scene as per requirement.
	return img
end

-- for creating objects using Box2d image
function drawImageBox2dUtil(x, y,imagename,type,isSensor,scale)
	--if IsSensor = true then Box2d image will not collide with another Box2d image
	
	local imgBox2d = Bitmap.new(Texture.new(imagename))
	imgBox2d:setAnchorPoint(0.5,0.5)
	imgBox2d:setPosition(x,y)
	
	--get radius
	local radius = imgBox2d:getWidth()/2
	
	--create box2d physical object
	local body = self.world:createBody{type = type or b2.DYNAMIC_BODY,fixedRotation = true, linearDamping = 1}
	body:setPosition(imgBox2d:getX(), imgBox2d:getY())
	body:setAngle(imgBox2d:getRotation() * math.pi/180)
	--local circle = b2.CircleShape.new(0, 0, radius)
	local poly = b2.PolygonShape.new()
	poly:setAsBox(imgBox2d:getWidth()/2, imgBox2d:getHeight()/2)
	local fixture = body:createFixture{shape = poly, density = 1.0,friction = 0, restitution = 0,isSensor = isSensor or false}
	imgBox2d.body = body
	imgBox2d.body.name = imagename
	imgBox2d:setScale(scale or 1)

	--self:addChild(imgBox2d) --add to respective scene as per requirement.
	
	--return created object
	return imgBox2d
end
function drawShapeUtil(x, y,shapeColor,lineColor)
	local shape = Shape.new()
	shape:setFillStyle(Shape.SOLID, shapeColor or 0xffffff)
	shape:setLineStyle(5, lineColor or 0xd3d3d3, 0.5)--(x)px width ,(x) color line ,(x) alpha 
	shape:beginPath()
	shape:moveTo(0,0)
	shape:lineTo(0, 20)
	shape:lineTo(20, 20)
	shape:lineTo(20, 0)
	shape:lineTo(0, 0)
	shape:endPath()
	shape:setPosition(x, y)
	--stage:addChild(shape)
	return shape
end

-- Create a text filed
function textFieldUtil(theText, xPos, yPos, theFontSize, theFontName,textColor,adjustWidth)
	local xPos, yPos  = xPos or 0, yPos or 0
	local theFontSize = theFontSize or 16
	local theFontName = theFontName or "fonts/JUNEBUG_.ttf"
	local textColor   = textColor or 0xFFFFFF
	local _font       = TTFont.new(theFontName, theFontSize, true)
	local _text       = TextField.new(_font,theText)
	local _adjustWidth= adjustWidth or false
	--_text:setTextColor(0xFFFFFF)
	_text:setTextColor(textColor)
	_text.width       = _text:getWidth()
	_text.height      = _text:getHeight()
	--_text:setAnchorPoint(0.5,0.5)-- not supported now
	--stage:addChild(_text)
	--screenW/2-50==3,4
	--screenW/2-90==5,6
	if(_adjustWidth==false) then
		_text:setPosition(xPos, yPos - _text.height) -- Gideros uses baseline font
	else	
		if(string.len(theText) == 3 or string.len(theText) == 4) then
			_text:setPosition(screenW/2-50, yPos - _text.height)
		elseif(string.len(theText) == 5 or string.len(theText) == 6) then
			_text:setPosition(screenW/2-90, yPos - _text.height)
		else	
			_text:setPosition(xPos, yPos - _text.height)
		end
	end	
	return _text
end

-- To colorize image (can colorize only image with white bg not transperent"
function colorizeImageUtil(theObject, theColor, colorArr)
	if theColor < 1 or theColor > #colorArr then
		return
	end  

	local r, g, b, a = unpack(colors[theColor])
	a = a or 255
	r = r / 255  
	g = g / 255  
	b = b / 255 
	a = a / 255

	theObject:setColorTransform(r, g, b, a)
end 

function threeRandomNumbersUtil(range)
	local arr = {0,0,0}
	local count = 1
	local forCount = 2
	while true do 
		local randomnumber = math.random(1,range or #colors)
		--print(count.."  randomNumber =    "..randomnumber)
			if(count==1) then
			arr[1] = randomnumber
			else
				for i=1, #arr do 
				--print("arr[i]  == ".. i .."   val = "..arr[i])
				if(arr[i] == randomnumber) then
					--print(" equal for i ==> "..i)
				 break
				 elseif(arr[i] ~= randomnumber and arr[i] == 0 ) then
					arr[i] = randomnumber
					forCount = forCount+1
					--print("arr[i]  ==> "..i.."  =  "..arr[i])
				 break				
				end	
			
			end
			end
	  count = count+1
	  if(forCount==(#arr+1)) then
		break
	  end	
    end		
	--print("FINAL : "..arr[1]..arr[2]..arr[3])
	return arr
end

function threeRandomImagesUtil(stringName, stringArrayAll)
	local arr = {stringName,0,0}
	local count = 1
	local forCount = 2
	
	local splittedNameArray = splitStringByUnderscore(stringName)
	
	while true do 
		local randomString = stringArrayAll[math.random(1, #stringArrayAll)];
		local randomSplittedTempArray = splitStringByUnderscore(randomString)
							
		for i=1, #arr do 
			local splittedTempArray = splitStringByUnderscore(arr[i])	
			if(splittedTempArray[0] == randomSplittedTempArray[0]) then
				--print(" equal for i ==> "..i)
				break
			elseif(arr[i] == 0) then
				arr[i] = randomString
				forCount = forCount+1
				--print("save to array ==> at arr["..i.."]   => "..randomString)
				break				
			end	
		end
			
	  count = count+1
	  if(forCount==(#arr+1)) then
		break
	  end	
    end		
	--print("FINAL :   "..arr[1].."   "..arr[2].."   "..arr[3])
	return arr
end


function splitStringByUnderscore(stringName)
	local i=0
	local splittedNameArray = {"",""}
	for word in string.gmatch(stringName, '([^_]+)') do
		--print("splitted =========>>> "..word)
		splittedNameArray[i] = word
		i = i+1
	end
	
	return splittedNameArray
end


function generateRandomImageUtil(imageNum,imgArr)
	local image
	local _imgArr = imgArr or allImageNames
	local tmpNum = imageNum or math.random(1,#_imgArr)
	image = _imgArr[tmpNum]
	
	return image	
end

-- Remove an object when done
function destroyObjectUtil(theObject)
	if theObject == nil then 
		return 
	end 
	theObject:removeFromParent()
end

--Play the sound as specified
function playSoundUtil(theSound)
	if sounds.isOn then
		if theSound == nil then 
			return 
		end 
		local channel = theSound:play()
		return channel
	else
		return
	end	
end

--set position with effect
function Sprite:setPositionTweenUtil(posX,posY)        
 --obj:setPosition(obj:getX()-20, obj:getY()-20)
 --GTween.new(obj, 0.25, {x = obj:getX()+20,y = obj:getY()+20}, {delay = 0, ease = easing.outBounce })
 GTween.new(self, 10, {x = posX,y = posY}, {delay = 0})
end

-- Change the visibility of the object
function setVisibilityUtil(theObject, setHow)
	if theObject == nil then 
		return 
	end
	
	theObject:setVisible(setHow or false)
end
-- Get the visibility of the object
function isVisibleUtil(theObject)
	if theObject == nil then 
		return false 
	end
	return theObject:isVisible()
end
-- The collision checking function that checks if a rect1 overlaps rect2
function collisionCheckUtil(rect1, rect2)
	if(rect1==nil or rect2==nil) then
		return false
	end	
	local x,y,w,h = rect1:getX()-10,rect1:getY()-10, rect1:getWidth()-10 or 10, rect1:getHeight()-10 or 10--rect1:getBounds(stage)--
	local x2,y2,w2,h2 = rect2:getX()-10,rect2:getY()-10, rect2:getWidth()-10 or 10, rect2:getHeight()-10 or 10--rect2:getBounds(stage)--

	return not ((y+h < y2) or (y > y2+h2) or (x > x2+w2) or (x+w < x2))
end
