--let's create separate scene and hold everything there
--then it will be easier to reuse it if you want to use SceneManager class
gamescene = gideros.class(Sprite)

local _W = application:getContentWidth()
local _H = application:getContentHeight()
local mRandom = math.random

local score

local gemsTable = {}
local numberOfMarkedToDestroy = 0
local gemToBeDestroyed  			-- used as a placeholder
local isGemTouchEnabled = true 		-- blocker for double touching gems

function gamescene:init()
	
	self:createScene(self)

	-- register for mouse events
	self:addEventListener(Event.MOUSE_DOWN, self.onMouseDown, self)
	self:addEventListener(Event.MOUSE_MOVE, self.onMouseMove, self)
	--self:addEventListener(Event.MOUSE_UP, self.onMouseUp, self)
		
	--remove event on exiting scene
	self:addEventListener("exitBegin", self.onExitBegin, self)
	--handle back button
	self:addEventListener(Event.KEY_UP, self.onKeyUp , self) 
end

function gamescene:onMouseDown(event)
	    
end
	
function gamescene:onMouseMove(event)

end

function gamescene:onMouseUp(event)
	
end

-- Called when the scene's view does not exist:
function gamescene:createScene( event )
	--print( "\n1: createScene event")
 
    -- reseting values
    score		= 0
    --gemsTable
    for i = 1, 6, 1 do
    	gemsTable[i] = {}
		for j = 1, 6, 1 do
			gemsTable[i][j] = self:newGem(i,j,true)
			--*****if i declare touch events here it works but causes problems after some time, uncomment below and check youself to know.******
			--[[gemsTable[i][j]:addEventListener(Event.MOUSE_UP, function (event)
												self:onGemTouch(gemsTable[i][j],event)
											end)]]
 		end
		
 	end	
end


function gamescene:newGem(i,j,isFirstTime)
	local R = mRandom(1,4)

	newGem = nil
		
	if 		(R == 1 ) then 
		newGem = drawImageUtil(0,0,"images/fruit_stawberry.png",1)
		--newGem:setColorTransform(255, 0, 0)
		newGem.gemType = "red"
	
	elseif 	(R == 2 ) then 
		newGem = drawImageUtil(0,0,"images/fruit_pineapple.png",1)
		--newGem:setColorTransform( 0, 255, 0 )
		newGem.gemType = "green"
	
	elseif 	(R == 3 ) then 
		newGem = drawImageUtil(0,0,"images/fruit_grape.png",1)
		--newGem:setColorTransform( 0, 0, 255 )
		newGem.gemType = "blue"
	
	elseif 	(R == 4 ) then 
		newGem = drawImageUtil(0,0,"images/fruit_watermelon.png",1)
		--newGem:setColorTransform( 255, 255, 0 )
		newGem.gemType = "yellow"
	
	end
	
	newGem:setPosition((i*1.1)*45-12, -60)
	newGem.i = i
	newGem.j = j
	newGem.isMarkedToDestroy = false

	newGem.destination_y = ((j*1.1)*45)+50
	

	--new gem falling animation
	--transition.to( newGem, { time=100, y= newGem.destination_y} )
		
	self:addChild( newGem )
	if isFirstTime then
		GTween.new(newGem,0.5, {y = newGem.destination_y}, {ease = easing.inOutSine})
		--newGem:setY(newGem.destination_y)
	else
		--********Another problem is with Gtween, if i change the postion using this then its not working properly but if I directly change the postion then it works.
		--GTween.new(newGem, 0.5, {y = newGem.destination_y}, {ease = easing.inOutCircular})
		newGem:setY(newGem.destination_y)
	end	
	
	--*****If I declare touch event here then only last position is detected.. dont know why.*****
	newGem:addEventListener(Event.MOUSE_UP, function (event)
												self:onGemTouch(newGem,event)
											end)

return newGem
end

function gamescene:shiftGems () 

--print ("Shifting Gems")

	-- first roww
	for i = 1, 6, 1 do
			if gemsTable[i][1].isMarkedToDestroy then
					-- current gem must go to a 'gemToBeDestroyed' variable holder to prevent memory leaks
					-- cannot destroy it now as gemsTable will be sorted and elements moved down
					gemToBeDestroyed = gemsTable[i][1]
					
					-- create a new one
						gemsTable[i][1] = self:newGem(i,1,false)

					-- destroy old gem
					--gemToBeDestroyed:removeSelf()
					destroyObjectUtil(gemToBeDestroyed)
					gemToBeDestroyed = nil
			end
	end

	-- rest of the rows
	for j = 2, 6, 1 do  -- j = row number - need to do like this it needs to be checked row by row
		for i = 1, 6, 1 do
			
			if gemsTable[i][j].isMarkedToDestroy then --if you find and empty hole then shift down all gems in column
					gemToBeDestroyed = gemsTable[i][j]
				
					-- shiftin whole column down, element by element in one column
					for k = j, 2, -1 do -- starting from bottom - finishing at the second row
						-- curent markedToDestroy Gem is replaced by the one above in the gemsTable
						gemsTable[i][k] = gemsTable[i][k-1]
						gemsTable[i][k].destination_y = gemsTable[i][k].destination_y +50
						--GTween.new(gemsTable[i][k], 0.1, {y = gemsTable[i][k].destination_y}, {ease = easing.inOutCircular})
						gemsTable[i][k]:setY(gemsTable[i][k].destination_y)
						-- we change its j value as it has been 'moved down' in the gemsTable
						gemsTable[i][k].j = gemsTable[i][k].j + 1
					end
					-- create a new gem at the first row as there is en ampty space due to gems
					-- that have been moved in the column
						gemsTable[i][1] = self:newGem(i,1,false)
					-- destroy the old gem (the one that was invisible and placed in gemToBeDestroyed holder)
						destroyObjectUtil(gemToBeDestroyed)
						gemToBeDestroyed = nil
					
			end 
		end
	end
	--self:refreshGemTouch()
end --shiftGems()



function markToDestroy( gem )

	gem.isMarkedToDestroy = true
	numberOfMarkedToDestroy = numberOfMarkedToDestroy + 1
	
	-- check on the left
	if gem.i>1 then
		if (gemsTable[gem.i-1][gem.j]).isMarkedToDestroy == false then

			if (gemsTable[gem.i-1][gem.j]).gemType == gem.gemType then
			   markToDestroy( gemsTable[gem.i-1][gem.j] )
			end	 
		end
	end

	-- check on the right
	if gem.i<6 then
		if (gemsTable[gem.i+1][gem.j]).isMarkedToDestroy == false then

			if (gemsTable[gem.i+1][gem.j]).gemType == gem.gemType then
			    markToDestroy( gemsTable[gem.i+1][gem.j] )
			end	 
		end
	end

	-- check above
	if gem.j>1 then
		if (gemsTable[gem.i][gem.j-1]).isMarkedToDestroy == false then

			if (gemsTable[gem.i][gem.j-1]).gemType == gem.gemType then
			   markToDestroy( gemsTable[gem.i][gem.j-1] )
			end	 
		end
	end

	-- check below
	if gem.j<6 then
		if (gemsTable[gem.i][gem.j+1]).isMarkedToDestroy== false then
			if (gemsTable[gem.i][gem.j+1]).gemType == gem.gemType then
			   markToDestroy( gemsTable[gem.i][gem.j+1] )
			end	 
		end
	end
end



function gamescene:enableGemTouch()

	isGemTouchEnabled = true
end



function gamescene:destroyGems()
	--print ("Destroying Gems. Marked to Destroy = "..numberOfMarkedToDestroy)


	for i = 1, 6, 1 do
		for j = 1, 6, 1 do
			
			if gemsTable[i][j].isMarkedToDestroy then

				isGemTouchEnabled = false
				GTween.new(gemsTable[i][j], 0.3, {alpha=0.2,scaleX = 2, scaleY = 2,onComplete=self:enableGemTouch()}, {ease = easing.linear})
				--GTween.new(gemsTable[i][j], 0.3, {scaleX = 0.85, scaleY = 0.85,onComplete=self:enableGemTouch()}, {ease = easing.linear})	
				-- update score
				score = score + 10
				--print(string.format( "SCORE: %6.0f", score ))
			end
		end
	end

	numberOfMarkedToDestroy = 0
	performAfterUtil(400,function ()
						self:enableGemTouch()
						self:shiftGems()
					end)

end



function gamescene:cleanUpGems()
	--print("Cleaning Up Gems")
		
	numberOfMarkedToDestroy = 0
	
	for i = 1, 6, 1 do
		for j = 1, 6, 1 do		
			-- show that there is not enough
			if gemsTable[i][j].isMarkedToDestroy then
				GTween.new(gemsTable[i][j], 0.15, {alpha=0.5,scaleX = 1.2, scaleY = 1.2}, {ease = easing.inOutCircular})
				GTween.new(gemsTable[i][j], 0.15, {alpha=1,scaleX = 1, scaleY = 1}, {delay=0.15,ease = easing.inOutCircular})
			end
			gemsTable[i][j].isMarkedToDestroy = false			
		end
	end
end

function gamescene:onGemTouch(newGem,event)	

	local t = event:getTarget()
	if(t:hitTestPoint(event.x, event.y)) then
		if isGemTouchEnabled then

			print("Gem touched i= "..newGem.i.." j= "..newGem.j)

			markToDestroy(newGem)
			
			if numberOfMarkedToDestroy >= 3 then
				self:destroyGems()
			else 
				self:cleanUpGems()
			end
		end
	end	
return true
end

function gamescene:refreshGemTouch()
	--***Tried to make a workaround but if i call this method after shifting , then it created multiple touch events after every shifting..
    for i = 1, 6, 1 do
		for j = 1, 6, 1 do
			gemsTable[i][j]:addEventListener(Event.MOUSE_UP, function (event)
												self:onGemTouch(gemsTable[i][j],event)
											end)
 		end
		
 	end
end

function printGemsTable()
	for i = 1, 6, 1 do
		for j = 1, 6, 1 do		
			print("column "..gemsTable[i][j].i.." row ".. gemsTable[i][j].j .. " "..gemsTable[i][j].gemType)
		end
	end
end

--removing event on exiting scene
--just in case you're using SceneManager
function gamescene:onExitBegin()
  --self:removeEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
  --self:resetGame()
end

function gamescene:onKeyUp(event)

	if event.keyCode == KeyCode.BACK then
		
	end
end

